package net.mcreator.watermelon_play_simulator.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;

import net.mcreator.watermelon_play_simulator.world.inventory.DatasBookGuiMenu;
import net.mcreator.watermelon_play_simulator.procedures.ShownameProcedure;
import net.mcreator.watermelon_play_simulator.procedures.ShowlvProcedure;
import net.mcreator.watermelon_play_simulator.procedures.ShowexpProcedure;
import net.mcreator.watermelon_play_simulator.network.DatasBookGuiButtonMessage;
import net.mcreator.watermelon_play_simulator.WatermelonPlaySimulator2Mod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class DatasBookGuiScreen extends AbstractContainerScreen<DatasBookGuiMenu> {
	private final static HashMap<String, Object> guistate = DatasBookGuiMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_upgrade;

	public DatasBookGuiScreen(DatasBookGuiMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 300;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = new ResourceLocation("watermelon_play_simulator_2:textures/screens/datas_book_gui.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, Component.translatable("gui.watermelon_play_simulator_2.datas_book_gui.label_your_experience"), 5, 42, -12829636);
		this.font.draw(poseStack,

				ShowexpProcedure.execute(entity), 95, 42, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.watermelon_play_simulator_2.datas_book_gui.label_your_lv"), 5, 24, -12829636);
		this.font.draw(poseStack,

				ShowlvProcedure.execute(entity), 50, 24, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.watermelon_play_simulator_2.datas_book_gui.label_skill_points155lv"), 5, 60, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.watermelon_play_simulator_2.datas_book_gui.label_your_name"), 5, 6, -12829636);
		this.font.draw(poseStack,

				ShownameProcedure.execute(entity), 59, 6, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
	}

	@Override
	public void init() {
		super.init();
		button_upgrade = Button.builder(Component.translatable("gui.watermelon_play_simulator_2.datas_book_gui.button_upgrade"), e -> {
			if (true) {
				WatermelonPlaySimulator2Mod.PACKET_HANDLER.sendToServer(new DatasBookGuiButtonMessage(0, x, y, z));
				DatasBookGuiButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 113, this.topPos + 159, 61, 20).build();
		guistate.put("button:button_upgrade", button_upgrade);
		this.addRenderableWidget(button_upgrade);
	}
}
